<%
sub editcategory
	Dim CatID, PatCatID, CatName, MetaDesc, KetaKey, CatDepth, Status, CatRec
	Dim fso, f
	if isnull(Request.Form("CatID")) or isempty(Request.Form("CatID")) or _
	trim(Request.Form("CatID")) = "" then
		Response.Write "You lose your category ID for some reason"
		exit sub
	else
		'msginfo("CatID is " & Request("CatID"))
		CatID = Clng(Request("CatID"))	
	end if
	Status = validate_category_input
	if strcomp(Status, "ok", vbtextcompare) <> 0 then
		html_cat_edit_failure Status
		exit sub	
	end if
	
	select case Request.Form("editcatrecord")
		case "Edit Record":
			Set fso = Server.CreateObject("Scripting.FileSystemObject")
			modifyonecategory CatID
			' After a record is modified, we redirect back to this category
			getcategory CatID
		case "Delete Record":
			if CatID = 0 then
				html_cat_edit_failure "You can't delete the root category"
				exit sub
			end if
			PatCatID = deleteonecategory(CatID)
			' After a record is deleted we redirect back to upper category
			getcategory PatCatID
		case else
			html_cat_edit_failure "You lose your command for some reason"	
	end select
	
	'info
end sub

function deleteonecategory(CatID)
	Dim SelfCatRec, PatHood, len_PatHood
	Dim fso, f, first, last, i, j, alllines, singlerec, lastindex
	Dim catresult()
	
	getselfcat CatID, SelfCatRec
	deleteonecategory = SelfCatRec(cat_col_patcatid)
	
	len_PatHood = len(SelfCatRec(cat_col_pathood))
	PatHood = SelfCatRec(cat_col_pathood)
	msginfo("SelfCatRec's PatHood is " & PatHood)
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	
	'Get all the category
	Set f = fso.OpenTextFile(db_category_name, forreading, false)
	alllines = split(f.readall, vbCrlf, -1, vbtextcompare)
	last = Ubound(alllines) - 1
	msginfo("Last is "  & last)
	f.close ' Close file
	lastindex = 0
	ReDim result(last-1)
	for i = 0 to last
		singlerec = split(alllines(i), db_delim, -1, vbtextcompare)
		if instr(1, PatHood, mid(singlerec(cat_col_pathood), 1, len_PatHood), vbtextcompare) > 0 _
			and len(singlerec(cat_col_pathood)) < len_PatHood then
			result(lastindex) = alllines(i)
			lastindex = lastindex + 1
		elseif instr(1, mid(singlerec(cat_col_pathood), 1, len_PatHood), PatHood, vbtextcompare) <= 0 then
			result(lastindex) = alllines(i)
			lastindex = lastindex + 1
		else
			' The sub cateogries must be deleted as well. do nothing here
			msginfo("Delete this cat and id is " & i & " and Pathood is " & singlerec(cat_col_pathood))
			lastindex = lastindex			
		end if
	next
	ReDim preserve result(lastindex)
	'Write the result back to file
	Set f = fso.OpenTextFile(db_category_name, forwriting, false)
	f.write join(result, vbCrlf)
	f.close
	Set f = nothing
	Set fso = nothing
	
end function

sub modifyonecategory(CatID)
	Dim fso, f, first, last, i, NextCatID, singlerec, alllines, line, OrigCatName, OrigPatHood, NewPatHood
	Dim PatHoodChanged, rawlines
	PatHoodChanged = false ' Assuming the Cat Name is not changed
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	
	'Get all the category
	Set f = fso.OpenTextFile(db_category_name, forreading, false)
	alllines = split(f.readall, vbCrlf, -1, vbtextcompare)
	last = Ubound(alllines)
	f.close ' Close file
	for i = 0 to last - 1
		singlerec = split(alllines(i), db_delim, -1, vbtextcompare)
		if Clng(singlerec(cat_col_id)) = CatID then
			'Modify the single cat rec
			OrigCatName = singlerec(cat_col_name) ' Keep the part that constructs the PatHood
			singlerec(cat_col_name) = nullif(Request.Form("Name"))
			singlerec(cat_col_des) = nullif(Request.Form("Description"))
			singlerec(cat_col_metades) = nullif(Request.Form("Meta Description"))
			singlerec(cat_col_metakey) = nullif(Request.Form("Meta Keywords"))
			singlerec(cat_col_header) = nullif(Request.Form("Header"))
			singlerec(cat_col_footer) = nullif(Request.Form("Footer"))
			singlerec(cat_col_date) = Formatdatetime(date, 1) ' Long format date
			if strcomp(nullif(Request.Form("CLinked")),"YES", vbtextcompare) = 0 then
				singlerec(cat_col_clinks) = 1
			else
				singlerec(cat_col_clinks) = 0
			end if
			if Strcomp(singlerec(cat_col_name), OrigCatName, vbtextcompare) <> 0 then
				OrigPathood = singlerec(cat_col_pathood)
				last = instrrev(singlerec(cat_col_pathood), ":", -1, vbtextcompare)
				'msginfo("The last is " & last)
				'msginfo("The old pathood is " & singlerec(cat_col_pathood))
				'msginfo("OrigCatName is " & OrigCatName)
				'msginfo("Cat Name is " & singlerec(cat_col_name))
				NewPatHood = mid(singlerec(cat_col_pathood), 1, last) & _
				replace(singlerec(cat_col_pathood), OrigCatName, singlerec(cat_col_name), last + 1, 1, vbtextcompare)
				'msginfo("The new pathood is " & singlerec(cat_col_pathood))
				PatHoodChanged = true
			end if
			alllines(i) = join(singlerec, db_delim)
			rawlines = join(alllines, vbCrlf)
			Set alllines = nothing
			if PatHoodChanged then ' Replace all the pathood
				rawlines = replace(rawlines, OrigPatHood, NewPatHood, 1, -1, vbtextcompare)
			end if
			'Write the rawlines back to db category file
			Application.Lock
				Set f = fso.OpenTextFile(db_category_name, forwriting, false)
				f.write rawlines
				f.close
			Application.UnLock
			Set f = nothing
			Set fso = nothing
			exit for
		end if
	next
end sub

' Decreas the catcount when a link is deleted
sub decreasecatcount(PatHood)
	Dim fso, f, alllines, singlerec, i, first, last, len_PatHood
	len_PatHood = len(PatHood)
	Application.Lock
		Set fso = Server.CreateObject("Scripting.FileSystemObject")
		Set f = fso.OpenTextFile(db_category_name, forreading, false)
		alllines = split(f.readall, vbCrlf, -1, vbtextcompare)
		last = Ubound(alllines) - 1
		for i = 0 to last 
			singlerec = split(alllines(i), db_delim, -1, vbtextcompare)
			if instr(1, PatHood, mid(singlerec(cat_col_pathood), 1, len_PatHood), vbtextcompare) > 0 _
			and len(singlerec(cat_col_pathood)) < len_PatHood then
				singlerec(cat_col_count) = Clng(singlerec(cat_col_count)) - 1
				alllines(i) = join(singlerec, db_delim)
			end if
		next
		Set f = fso.OpenTextFile(db_category_name, forwriting, false)
		f.write join(alllines, vbCrlf)
		f.close
	Application.UnLock
	Set f = nothing
	Set fso = nothing
end sub

' increase the catcount when a link is added
sub increasecatcount(PatHood)
	Dim fso, f, alllines, singlerec, i, first, last, len_PatHood
	len_PatHood = len(PatHood)
	Application.Lock
		Set fso = Server.CreateObject("Scripting.FileSystemObject")
		Set f = fso.OpenTextFile(db_category_name, forreading, false)
		alllines = split(f.readall, vbCrlf, -1, vbtextcompare)
		last = Ubound(alllines) - 1
		for i = 0 to last 
			singlerec = split(alllines(i), db_delim, -1, vbtextcompare)
			if instr(1, PatHood, mid(singlerec(cat_col_pathood), 1, len_PatHood), vbtextcompare) > 0 _
			and len(singlerec(cat_col_pathood)) < len_PatHood then
				singlerec(cat_col_count) = Clng(singlerec(cat_col_count)) + 1
				alllines(i) = join(singlerec, db_delim)
			end if
		next
		Set f = fso.OpenTextFile(db_category_name, forwriting, false)
		f.write join(alllines, vbCrlf)
		f.close
	Application.UnLock
	Set f = nothing
	Set fso = nothing
end sub

'Modify all the sub category's parenthood
function modcatrec(CatID, byref Clinked, byref SelfCatRec)
	Dim fso, f, alllines, line, first, last, lastindex, i, singlerec, result
	result = inithash
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	Set f = fso.OpenTextFile(db_category_name, ForReading, false)
	'Read all into array alllines
	alllines = split(f.readall, vbCrlf, -1, vbtextcompare)
	last = Ubound(alllines)
	Clinked = false
	'msginfo("Last is " & last)
	for i = 0 to last - 1
		singlerec = split(alllines(i), "|", -1, vbtextcompare)
		if Clng(singlerec(cat_col_id)) = CatID then
			SelfCatRec = singlerec
			if Clng(singlerec(cat_col_clinks)) = 1 then
				Clinked = true
			end if
		end if
		'msginfo("The cat_col_patcatid is " & singlerec(cat_col_patcatid))
		if Clng(singlerec(cat_col_patcatid)) = CatID then
			additem result, singlerec(cat_col_id), singlerec(cat_col_name)
		end if
	next
	getcatrec = result
	Set fso = nothing
end function

function validate_category_input
	'if isnull(Request.Form("Name")) or isempty(Request.Form("Name")) then
	if trim(Request.Form("Name")) = "" then
		validate_category_input = "Name (Can't not Left Blank) "
	else
		validate_category_input = "ok"
	end if
end function
%>

<%
sub html_cat_edit_failure (Status)
%>
        <form action="<%= db_script_url%>?action=editcategory" method="POST" id=form1 name=form1>
	    <input type=hidden name="CatID" value="<%= Request.Form("CatID") %>">
        <table border=1 bgcolor="#FFFFFF" cellpadding=5 cellspacing=3 width=500 valign=top>
            <tr><td colspan=2 bgcolor="navy">
                    <FONT FACE="MS Sans Serif, arial,helvetica" size=1 COLOR="#FFFFFF">
                    <<b>Category Database: Error: Unable to Edit Category</b>
            </td></tr>
            <tr><td>
                    <p><center><<%= sfont_title%>><b>
                        Error: <font color=red>Unable to Edit Category</font>
                    </b></font></center><br>
                    <<%= sfont%>>There were problems with the following fields: 
                    <FONT COLOR="red"><B><%= Status %></B></FONT>
                        <P>Please fix any errors and submit the record again.</p></font>
                        
                        <p><table border=1>
                        <tr><td align=right valign=top width=20%><<%= sfont%>>Name:
                        </font></td><td width=80%><input type=text name="Name" value="<%= nullif(Request.Form("Name")) %>" size="40" maxlength="75"></td></tr>
                        
						<tr><td align=right valign=top width=20%><<%= sfont%>>Description:</font></td><td width=80%>
						<textarea wrap="virtual" name="Description" cols="40" rows="3"><%= nullif(Request.Form("Description")) %></textarea></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Meta Description:</font></td>
						<td width=80%><input type=text name="Meta Description" value="<%= nullif(Request.Form("Meta Description")) %>" size="40" maxlength="75"></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Meta Keywords:</font></td>
						<td width=80%><input type=text name="Meta Keywords" value="<%= nullif(Request.Form("Meta Keywords")) %>" size="40" maxlength="75"></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Header:</font></td>
						<td width=80%><input type=text name="Header" value="<%= nullif(Request.Form("Header")) %>" size="40" maxlength="75"></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Footer:</font></td>
						<td width=80%><input type=text name="Footer" value="<%= nullif(Request.Form("Footer")) %>" size="40" maxlength="75"></td></tr>
					
						<% if strcomp(nullif(Request.Form("CLinked")),"YES", vbtextcompare) = 0 then %>
						<tr><td align=right valign=top width=20%><<%= sfont%>>Contain Links:</font></td>
						<td width=80%><SELECT NAME="CLinked"  SIZE="1"><OPTION SELECTED>Yes<OPTION>No
						</SELECT></td></tr>
						<% else %>
						<tr><td align=right valign=top width=20%><<%= sfont%>>Contain Links:</font></td>
						<td width=80%><SELECT NAME="CLinked"  SIZE="1"><OPTION SELECTED>No<OPTION>Yes
						</SELECT></td></tr>
                        <% end if %>
                        </table></p>
                     </font></p>
                    <p><center> <INPUT TYPE="SUBMIT" NAME="editcatrecord" VALUE="Edit Record">
                     <INPUT TYPE="SUBMIT" NAME="editcatrecord" VALUE="Delete Record">  
                    <INPUT TYPE="RESET" VALUE="Reset Form" id=RESET1 name=RESET1></center></p>
                    
            </td></tr>
        </table>
    </form>


<%
end sub
%>
<%
sub editcategoryform()
	Dim CatID, fso, f, CatName, MetaDesc, KetaKey, CatDepth, Status, CatRec
	if isnull(Request.QueryString("CatID")) or isempty(Request.QueryString("CatID")) then
		CatID = 0
	else
		CatID = Clng(Request.QueryString("catID"))	
	end if
	
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	if not getselfcat(CatID, CatRec) then
		Response.Write "Can't find the category for some reason"
		exit sub
	end if
	
%>
	    <form action="<%= db_script_url%>?action=editcategory" method="POST">
	    <input type=hidden name="CatID" value="<%= CatID %>">
        <table border=1 bgcolor="#FFFFFF" cellpadding=5 cellspacing=3 width=500 valign=top>
            <tr><td colspan=2 bgcolor="navy">
                    <FONT FACE="MS Sans Serif, arial,helvetica" size=1 COLOR="#FFFFFF">
                    <b>Category Database: Edit an Existing Category</b>
            </td></tr>
            <tr><td>
                    <p><center><<%= sfont_title%>><b>
                        Edit an Existing Category
                    </b></font></center><br>
                    <<%= sfont%>>
                        <p><table border=1>
                        <tr><td align=right valign=top width=20%><<%= sfont%>>Name:
                        </font></td>
                        <td width=80%><input type=text name="Name" value="<%= CatRec(cat_col_name) %>" size="40" maxlength="75"></td></tr>
                        
						<tr><td align=right valign=top width=20%><<%= sfont%>>Description:</font></td><td width=80%>
						<textarea wrap="virtual" name="Description" cols="40" rows="3"><%= CatRec(cat_col_des) %></textarea></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Meta Description:</font></td>
						<td width=80%><input type=text name="Meta Description" value="<%= CatRec(cat_col_metades) %>" size="40" maxlength="75"></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Meta Keywords:</font></td>
						<td width=80%><input type=text name="Meta Keywords" value="<%= CatRec(cat_col_metakey) %>" size="40" maxlength="75"></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Header:</font></td>
						<td width=80%><input type=text name="Header" value="<%= CatRec(cat_col_header) %>" size="40" maxlength="75"></td></tr>
						
						<tr><td align=right valign=top width=20%><<%= sfont%>>Footer:</font></td>
						<td width=80%><input type=text name="Footer" value="<%= CatRec(cat_col_footer) %>" size="40" maxlength="75"></td></tr>
					
						<% if Cint(CatRec(cat_col_clinks)) = 1 then %>
						<tr><td align=right valign=top width=20%><<%= sfont%>>Contain Links:</font></td>
						<td width=80%><SELECT NAME="CLinked"  SIZE="1"><OPTION SELECTED>Yes<OPTION>No
						</SELECT></td></tr>
						<% else %>
						<tr><td align=right valign=top width=20%><<%= sfont%>>Contain Links:</font></td>
						<td width=80%><SELECT NAME="CLinked"  SIZE="1"><OPTION SELECTED>No<OPTION>Yes
						</SELECT></td></tr>
                        <% end if %>
						
						
                        </table></p>
                    </font></p>
                    <p><center> <INPUT TYPE="SUBMIT" NAME="editcatrecord" VALUE="Edit Record"> 
                    <INPUT TYPE="SUBMIT" NAME="editcatrecord" VALUE="Delete Record"> 
                    <INPUT TYPE="RESET" VALUE="Reset Form"></center></p>
                    
            </td></tr>
        </table>
    </form>

<% end sub %>

