<%

function inithash()
	Dim tmp_array(1)
	tmp_array(0) = "Initialize Hash"
	tmp_array(1) = "The value is meaningless"
	inithash = tmp_array
end function

function counthash(an_array)
	'msginfo("The ubound of counthash is " & Ubound(an_array))
	counthash = Fix(ubound(an_array)/2)
	'msginfo("Counthashs is " & counthash)
end function

function copyarray(srcarray)
	Dim temparray()
	ReDmi temparray(ubound(srcarray))
	for i = 0 to Ubound(srcarray)
		temparray(i) = srcarray(i)
	next
	copyarray = temparray

end function

sub AddItem(byref an_array, key, item)
	Dim lastindex
	'msginfo("Insde Additem")
	lastindex = Ubound(an_array)
	'msginfo("Lastindex of AddItem is " & lastindex)
	ReDim preserve an_array(lastindex + 2)
	an_array(lastindex + 1) = key
	an_array(lastindex + 2) = item
end sub

function itemindexvalue(an_array, index)
	if index <= counthash(an_array) then
		itemindexvalue = an_array(2*index+1)
	else
		itemindexvalue = ""
	end if
end function

function itemindexkey(an_array, index)
	if index <= counthash(an_array) and index <> 0 then
		itemindexkey = an_array(2*index)
	else
		itemindexkey = ""
	end if
end function

function itemvalue(an_array, key)
	Dim index
	index = keyexist(an_array, key)
	if index <> -1 then
		itemvalue = an_array(2*index+1)
	else
		itemvalue = ""
	end if
end function

sub changeitembyindex(byref an_array, index, item)
	if index <= counthash(an_array) then
		an_array(2*index+1) = item
	end if	
end sub

sub changeitem(byref an_array, key, item)
	Dim index
	index = keyexist(an_array, key)
	if index = -1 then
		additem an_array, key, item
	else
		an_array(2*index+1) = item
	end if

end sub

function deletekey(an_array, key)
	Dim index, tmp_array
	if counthash(an_array) = 0 then
		deletekey = false
		exit function
	end if
	
	index = keyexist(an_array, key)
	if index = -1 then
		deletekey = false
		exit function
	elseif (2*index + 2) < Ubound(an_array) then
		for i = 2*index + 2 to Ubound(an_array)
			an_array(i-2) = an_array(i)
		next
		Redim preserve an_array(Ubound(an_array) - 2)
		deletekey = true
		exit function
	else
		Redim preserve an_array(Ubound(an_array)-2)
		deletekey = true
		exit function
	end if
end function

function changekey(byref an_array, key1, key2)
	Dim index
	index = keyexist(an_array, key)
	if index = -1 then
		changekey = false
		exit function
	else
		an_array(2*index+1) = key2
		changekey =true
		exit function
	end if
	
end function

function keyexist(an_array, key)
	Dim i, index
	if counthash(an_array) = 0 then
		keyexist = -1
		exit function
	end if
	for i = 2 to Ubound(an_array) step 2
		if strcomp(an_array(i), key, vbbinarycompare) = 0 then
			keyexist = i / 2
			exit function
		end if
	next
	keyexist = -1
end function

function hashtoarray(an_array)
	Dim tmp_array()
	if counthash(an_array) = 0 then
		hashtoarray = Null
	else
		Redim tmp_array(Ubound(an_array)-2)
		for i = 2 to Ubound(an_array)
			tmp_array(i) = an_array(i)
		next
		hashtoarray = tmp_array
	end if
end function

function hashkeys(an_array)
	Dim tmp_array(), lastindex
	'msginfo("Inside hash keys")
	lastindex = counthash(an_array)	
	'msginfo("Lastindex of hashkey is " & lastindex)
	if lastindex < 1 then
		'msginfo("There is noting inside the hash key")
		hashkeys = ""
	end if
	ReDim tmp_array(lastindex-1)
	for i = 0 to lastindex - 1
		tmp_array(i) = an_array(2*(i+1))
	next
	hashkeys = tmp_array
	'msginfo("The array num is " & ubound(hashkeys))
end function

function arraytohash(an_array)
	Dim tmphash
	tmphash = inithash()
	for i = 0 to Ubound(an_array) step 2
		additem tmphash, an_array(i), an_array(i+1)
	next
	arraytohash = tmphash
end function


'direction d - descend a - ascend
function sortbystringkey(a, direction)
	
	Dim i, index, j, finish, tmpindex, tmpv, firstrec, secondrec, lastindex
	lastindex = counthash(a)
	msginfo("lastindex is " & lastindex)
	if lastindex < 2 then
		sortbystringkey = a
		exit function
	end if
	
	
	for i = 1 to lastindex
		for j = 1 to i
			if direction = "d" then
				if strcomp(a(2*i),a(2*j), vbbinarycompare) > 0 then
					tmpindex = a(2*j)
					tmpv = a(2*j+1)
					a(2*j) = a(2*i)
					a(2*j+1) = a(2*i+1)
					a(2*i) = tmpindex
					a(2*i+1) = tmpv
				end if
			else
				if strcomp(a(2*i),a(2*j), vbbinarycompare) < 0 then
					tmpindex = a(2*j)
					tmpv = a(2*j+1)
					a(2*j) = a(2*i)
					a(2*j+1) = a(2*i+1)
					a(2*i) = tmpindex
					a(2*i+1) = tmpv
				end if
			end if
		next
	next
	
	sortbystringkey = a
end function

function sortbyintkey(a, direction)
 
	Dim i, index, j, finish, tmpindex, tmpv, firstrec, secondrec, lastindex
	
	lastindex = counthash(a)
	
	if lastindex < 2 then
		sortbyintkey = a
		exit function
	end if
	
	
	for i = 1 to lastindex
		for j = 1 to i
			if direction = "d" then
				if Cint(a(2*i)) > Cint(a(2*j)) then
					tmpindex = a(2*j)
					tmpv = a(2*j+1)
					a(2*j) = a(2*i)
					a(2*j+1) = a(2*i+1)
					a(2*i) = tmpindex
					a(2*i+1) = tmpv
				end if
			else
				if Cint(a(2*i)) < Cint(a(2*j)) < 0 then
					tmpindex = a(2*j)
					tmpv = a(2*j+1)
					a(2*j) = a(2*i)
					a(2*j+1) = a(2*i+1)
					a(2*i) = tmpindex
					a(2*i+1) = tmpv
				end if
			end if
		next
	next
	
	sortbyintkey = a
end function

' For debugging purpose
sub printarray(byref an_array)
	Dim i
	'msginfo("inside printarray")
	if isarray(an_array) then
		for i = 0 to Ubound(an_array)
			msginfo("The " & i & " is " & an_array(i))
		next
	else
		msginfo("This is not an array")
	end if
end sub

function filetohash(filename)
	Dim i, first, last, alllines, tmp_hash
	Dim fso, f
	tmp_hash = inithash
	msginfo("Inside filetohash. The filename is " & filename)
	on error resume next
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	Set f = fso.OpenTextFile(filename, ForReading, false)
	alllines = split(f.readall, vbcrlf, -1, vbtextcompare)
	f.close
	Set f = nothing
	Set fso = nothing
	on error goto 0
	msginfo("Isarray(alllines) " & isarray(alllines))
	if isarray(alllines) then
		last = Ubound(alllines) - 1
	else
		filetohash = tmp_hash
		exit function
	end if
	msginfo("Last is " & last)
	if last >= 0 then
		ReDim preserve tmp_hash(2*(last+1) + 1)
		for i = 0 to last
			singlerec = split(alllines(i), db_delim, -1, vbtextcompare)
			tmp_hash(2*(i+1)) = singlerec(0)
			tmp_hash(2*(i+1)+1) = alllines(i)
		next
	end if
	filetohash = tmp_hash
	
end function
%>

